
(defun c:textfind ( / ss ssc ssl t2f entl tv ip stat _cassens oldcmd findlag )
   (setq oldcmd (getvar "cmdecho"))
   (setvar "cmdecho" 0)
   (setq ss (ssget "x" '((0 . "TEXT"))))
   (if ss
       (progn
         (setq t2f (getval))
         (setq ssl (sslength ss)
               ssc 0
         )
         (while (< ssc ssl)
           (setq entl (entget (ssname ss ssc))
                 tv (cdr (assoc 1 entl))
                 ip (cdr (assoc 10 entl))
           )
           (if _cassens
             (setq par (= tv t2f))
             (setq par (= (strcase tv)(strcase t2f)))
           )
           (if par
               (progn
                (setq findflag T)
                (command ".zoom" "c" ip "")
                  (setq dcl_id (load_dialog "textfind"))
                  (new_dialog "cont" dcl_id "" '(10 10))
                  (action_tile "Yes" "(done_dialog 1)")
                  (action_tile "No" "(done_dialog 0)")
                  (mode_tile "accept" 1)
                  (mode_tile "Yes" 2)
                  (setq stat (start_dialog))
                  (unload_dialog dcl_id)
                  (if (= stat 0)
                    (setq ssc ssl)
                  )
               )
           )
           (setq ssc (1+ ssc))
         )
       )
       (xalert "No texts!")
   )
   (if (not findflag)
       (xalert "Text not found.")
   )
   (setvar "cmdecho" oldcmd)
   (setq _cassens nil)
   (princ)
)

;.........................................................................

(defun xalert ( mes / dcl_id )
  (setq dcl_id (load_dialog "textfind"))
  (new_dialog "xalert" dcl_id)
  (set_tile "message" mes)
  (start_dialog)
  (unload_dialog dcl_id)
)

;.........................................................................

(defun getval ( / dcl_id tret )
  (setq dcl_id (load_dialog "textfind"))
  (new_dialog "getval" dcl_id)
  (action_tile "getvalue" "(setq tret $value)")
  (action_tile "cason" "(setq _cassens T)")
  (action_tile "casoff" "(setq _cassens nil)")
  (mode_tile "getvalue" 2)
  (start_dialog)
  (unload_dialog dcl_id)
  tret
)

;.....................................................................
(defun c:tzoom ( / viewsize stat dcl_id )
  (setq viewsize (getvar "viewsize"))
  (if (not _par) (setq _par 1))
   (setq oldcmd (getvar "cmdecho"))
   (setvar "cmdecho" 0)
  (setq dcl_id (load_dialog "textfind"))
  (new_dialog "tzoom" dcl_id)
  (action_tile "zplus" "(done_dialog 0)")
  (action_tile "zminus" "(done_dialog 1)")
  (action_tile "accept" "(done_dialog 2)")
  (action_tile "zset" "(zoomset dcl_id)")
  (setq stat (start_dialog))
  (unload_dialog dcl_id)
  (cond ((= stat 0)
         (command ".zoom" "c" (getvar "viewctr") (/ viewsize _par))
        )
        ((= stat 1)
         (command ".zoom" "c" (getvar "viewctr") (* viewsize _par))
        )
  )
   (setvar "cmdecho" oldcmd)
  (princ)
)

;............................................
(defun zoomset ( dclid )
  (new_dialog "zoomset" dclid)
  (action_tile "slider" "(setq par (do_slider $value))")
  (set_tile "slider" (itoa _par))
  (set_tile "slider_info" (itoa _par))
  (start_dialog)
)

;..................................................

 (defun do_slider ( val )
    (setq _par (atoi val))
    (set_tile "slider" val)
    (set_tile "slider_info" val)
 )

;....................................................
;..............................................
(princ "\n  TEXTFIND by MALAM loaded.")
(princ)
